<?
// Copyright 2003,2004 by Hyunsik Choi <advanced at user.kldp.net>
// Copyright 2004 by Won-Kyu Park <wkpark at kldp.org>
// All rights reserved. Distributable under GPL see COPYING
// a MySQL Cache plugin for the MoniWiki
//
// $Id: mysql.php,v 1.2 2004/01/08 19:17:33 wkpark Exp $

class CacheBackend_MySQL { // MySQL
  var $handle; // DB handler
  var $result;

  function CacheBackend_MySQL($dbhost,$dbuser,$dbpass,$dbname){
    $this->host=$dbhost;
    $this->user=$dbuser;
    $this->pass=$dbpass;
    $this->name=$dbname;

    $this->connect($dbhost,$dbuser,$dbpass);
    if (!mysql_select_db($dbname))
      $this->errmsg();
  }

  function connect($host,$user,$password){
    $this->handle=mysql_connect($host,$user,$password);
    
    if(!$this->check_connect())
      $this->errmsg();
  }

  function query($query){
    $this->result = mysql_query($query);
    return $this->result;
  }

  function torow() {
    return mysql_fetch_row($this->result);
  }

  function close(){
    mysql_close($this->handle);
  }

  function check_connect(){
    if(is_resource($this->handle)==false)
      return false;
    else
      return true;
  }

  function errmsg(){
    die(mysql_errno()." : ".mysql_error());
  }
}

include_once("lib/dbcache.php");

class Cache_MySQL extends CacheSQL {
  var $arenas=array();

  function Cache_MySQL($DB) {
    $dbhost=$DB->db_host;
    $dbuser=$DB->db_user;
    $dbname=$DB->db_name;
    $dbpass=$DB->db_pass;

    $this->db = new CacheBackend_MySQL ($dbhost,$dbuser,$dbpass,$dbname);
    $this->wiki_db=$DB->sitename;
    # XXX sitename should be normalized.

    $this->arenas= $this->_get_arenas();

    register_shutdown_function(array(&$this,'close'));
  }

  function is_arena($arena) {
    if ($arena == 'text')
      return true;
    else if ($arena == 'html') {
      // XXX
      return false;
    }

    // add new arena dynamically
    // 
    if (!in_array($arena,$this->arenas)) {
      $this->add_arena($arena);
      $this->arenas[]=$arena;
    }

    #print $arena."<br>";
    return true;
  }

  function _get_arenas() {
    # get all exists fields from the cache of the wikisite
    $fields = mysql_list_fields($this->db->name, $this->wiki_db, $this->db->handle);
    $columns = mysql_num_fields($fields);

    for ($i = 0; $i < $columns; $i++) {
      $arenas[]= mysql_field_name($fields, $i);
#      print $arenas[$i]."<br />";
    }
    return $arenas;
  }

  function get_arena_type($arena) {
    $types=array('default'=>'MEDIUMTEXT',
                 'pagelinks'=>'TINYTEXT',
                # XXX 'counter'=>'', // XXX Counter class ??
                );
    if (array_key_exists($arena,$types)) {
      return $types[$arena];
    } else
      return $types['default'];
  }

  function add_arena($arena) {
    $type= $this->get_arena_type($arena);
    $this->db->query("ALTER TABLE $this->wiki_db ADD $arena $type");
    print ("ALTER TABLE $this->wiki_db ADD $arena $type");
    $this->result or mysql_error();
  }
}

?>
