<?php
// Copyright 2003,2004 by Hyunsik Choi <advanced at user.kldp.net>
// Copyright 2004 by Won-Kyu Park <wkpark at kldp.org>
// All rights reserved. Distributable under GPL see COPYING
// a SQL Cache module for the MoniWiki
//
// $Id: dbcache.php,v 1.2 2004/01/08 19:17:13 wkpark Exp $

class CacheSQL {
  var $db;
  var $wiki_db;
  var $arenas=array();

  function is_arena($arena) {
    return false;
  }

  function arenas() {
    return $this->arenas;
  }

  function add_arena($arena) {
  }

  function _pagekey($pagename) {
    return preg_replace("/([^a-z0-9]{1})/ie",
                        "'_'.strtolower(dechex(ord('\\1')))",$pagename);
  }

  function update($pagename,$arena='text',$value){
    $pagekey=$this->_pagekey($pagename);
    $val=addslashes($value);
    if($this->exists($pagename)){
      $this->db->query(
        "UPDATE $this->wiki_db SET $arena='$val' WHERE pagekey = '$pagekey'");
      $this->result or mysql_error();
      print 'update:'.$arena;
    } else {
      $this->db->query(
        "INSERT INTO $this->wiki_db (pagekey,$arena) ".
        "VALUES ('$pagekey','$val')");
      print 'insert:'.$arena;
    }
  }

  function fetch($pagename,$arena='text') {
    # fetch('HelloWorld','text');
    # fetch('HelloWorld','pagelinks');
    # fetch('HelloWorld','text,pagelinks');
    # fetch('HelloWorld',array('text','pagelinks');
    $pagekey=$this->_pagekey($pagename);
    $this->db->query(
      "SELECT $arena FROM $this->wiki_db WHERE ".
      "pagekey = '$pagekey'");
    $row = $this->db->torow();
    #print 'fetch:'.$arena;
    return $row[0];
  }

  function exists($pagename,$arena='pagekey') {
    $pagekey=$this->_pagekey($pagename);

    $this->db->query(
      "SELECT $arena FROM $this->wiki_db WHERE ".
      "pagekey = '$pagekey'");

    $this->result or mysql_error();
    #print 'OK--'.$arena."--".$row[0]."exists";
    $row = $this->db->torow();

    return $row[0] ? true:false;
  }

  function getPageLists() {
     // XXX
     $pages=array();
     $this->db->query(
       "SELECT pagename,utime FROM $this->wiki_db" );
     if($mode==1)
       $needle_key=$this->_pageKey($needle);
     else $needle_key=$needle;

     while($row = $this->db->torow()){
//         $pagename = $this->_pageKey($row[0]);
         $pagename = $row[0];
         $pages[] = $pagename;
//         $pages[$pagename] = $row[1];
     }
     return $pages;
  }

  function close() {
    $this->db->close();
  }
}
 
// vim:et:ts=8:sts=2:sw=2
?>
